/*
 * v.java
 *
 * Created on Piatok, 2004, oktber 15, 13:58
 */

/**
 *
 * @author  Marek Mizanin
 * This class is 3D vector, use float
 */
package graphics.math;

import graphics.math.vi;
import java.math.*;

public class v
{
	public float x,y,z;
	public static final float PI180 = 0.0174532925199432957692369076848861f;
	public static final float PI = 3.1415926535897932384626433832795f;
	/** Creates a new instance of v */
	public v(){}
	public v(float x_, float y_){x = x_; y = y_;}
	public v(float x_, float y_, float z_){x = x_; y = y_; z = z_;}
	public v(v a){x = a.x; y = a.y; z = a.z;}
	public v(vi a){x = (float)a.x; y = (float)a.y; }
	public void set(v a){x = a.x; y = a.y; z = a.z;}
	public void set(float x_, float y_, float z_){x = x_; y = y_; z = z_;}
	
	public void clear(){x = 0; y = 0 ;z = 0 ;}
	public void neg(){x = -x; y = -y; z = -z;}
	
	public void add(v a){x+=a.x; y+=a.y; z+=a.z;}
	public void sub(v a){x-=a.x; y-=a.y; z-=a.z;}
	public void mul(v a){x*=a.x; y*=a.y; z*=a.z;}
	public void div(v a){x/=a.x; y/=a.y; z/=a.z;}
	
	public void add(float a){x+=a; y+=a; z+=a;}
	public void sub(float a){x-=a; y-=a; z-=a;}
	public void mul(float a){x*=a; y*=a; z*=a;}
	public void div(float a){x/=a; y/=a; z/=a;}
	
	static public v neg(v a){return new v(-a.x, -a.y, -a.z);}
	static public v add(v a, v b){return new v(a.x+b.x, a.y+b.y, a.z+b.z);}
	static public v sub(v a, v b){return new v(a.x-b.x, a.y-b.y, a.z-b.z);}
	static public v mul(v a, v b){return new v(a.x*b.x, a.y*b.y, a.z*b.z);}
	static public v div(v a, v b){return new v(a.x/b.x, a.y/b.y, a.z/b.z);}
	
	static public v add(v a, float b){return new v(a.x+b, a.y+b, a.z+b);}
	static public v sub(v a, float b){return new v(a.x-b, a.y-b, a.z-b);}
	static public v mul(v a, float b){return new v(a.x*b, a.y*b, a.z*b);}
	static public v div(v a, float b){return new v(a.x/b, a.y/b, a.z/b);}
	
	static public v add(float a, v b){return new v(a+b.x, a+b.y, a+b.z);}
	static public v sub(float a, v b){return new v(a-b.x, a-b.y, a-b.z);}
	static public v mul(float a, v b){return new v(a*b.x, a*b.y, a*b.z);}
	static public v div(float a, v b){return new v(a/b.x, a/b.y, a/b.z);}	
	
	static public boolean less(v a, v b)		{return ((a.x< b.x)&&(a.y< b.y)&&(a.z< b.z));}
	static public boolean lessEqual(v a, v b)	{return ((a.x<=b.x)&&(a.y<=b.y)&&(a.z<=b.z));}
	static public boolean great(v a, v b)		{return ((a.x> b.x)&&(a.y> b.y)&&(a.z> b.z));}
	static public boolean greatEqual(v a, v b)	{return ((a.x>=b.x)&&(a.y>=b.y)&&(a.z>=b.z));}
	static public boolean equal(v a, v b)		{return ((a.x==b.x)&&(a.y==b.y)&&(a.z==b.z));}
	static public boolean noEqual(v a, v b)		{return ((a.x!=b.x)&&(a.y!=b.y)&&(a.z!=b.z));}
	
	static public v CROSS(v a, v b)
	{
		return new v(	a.y*b.z - a.z*b.y,			//  i   j   k
						a.z*b.x - a.x*b.z,			// a.x a.y a.z
						a.x*b.y - a.y*b.x );		// b.x b.y b.z	
	}
	static public float DOT3(v a, v b)
	{
		return (a.x*b.x + a.y*b.y + a.z*b.z);
	}
	static public float DOT3_clamp(v a, v b)
	{
		return Math.max(a.x*b.x + a.y*b.y + a.z*b.z,0.f);
	}
	public float DOT3(v a)
	{
		return (x*a.x + y*a.y +z*a.z);
	}
	public float Length()
	{	
		return (float) Math.sqrt(x*x + y*y + z*z);
	}

	public float Length2()
	{	
		return x*x + y*y + z*z;
	}

	public void RotX( float angle)
	{
		float s = (float) Math.sin( PI180*angle );
		float c = (float) Math.cos( PI180*angle );
		float Y=y;
		y =  y*c - z*s;
		z =  Y*s + z*c;
	}
	public void RotY( float angle)
	{
		float s = (float) Math.sin( PI180*angle );
		float c = (float) Math.cos( PI180*angle );
		float X=x;
		x =  x*c + z*s;
		z = -X*s + z*c;
	}
	public void RotZ( float angle)
	{
		float s = (float) Math.sin( PI180*angle );
		float c = (float) Math.cos( PI180*angle );
		float X=x;
		x =  x*c - y*s;
		y =  X*s + y*c;
	}
	public void Normalize()
	{
		float length;

		length = (float) Math.sqrt(x*x + y*y + z*z);
		if (length != 0) {
			x /= length;
			y /= length;
			z /= length;
		} else {
			x = 0;
			y = 0;
			z = 0;
		}
	}

	//	Rotate a vtor by angle theta around an arbitrary axis r
	//	Positive angles are anticlockwise looking down the axis  towards the origin.
	public void ArbitraryRotate(float theta, v ra)	// Rotate a vtor by angle theta around an arbitrary axis r
	{
		v p = new v(x,y,z);
		v r = new v(ra);
		float costheta,sintheta;

		theta*=PI180;
		r.Normalize();
		costheta = (float)Math.cos(theta);
		sintheta = (float)Math.sin(theta);

		x  = (costheta + (1 - costheta) * r.x * r.x) * p.x;
		x += ((1 - costheta) * r.x * r.y - r.z * sintheta) * p.y;
		x += ((1 - costheta) * r.x * r.z + r.y * sintheta) * p.z;

		y  = ((1 - costheta) * r.x * r.y + r.z * sintheta) * p.x;
		y += (costheta + (1 - costheta) * r.y * r.y) * p.y;
		y += ((1 - costheta) * r.y * r.z - r.x * sintheta) * p.z;

		z  = ((1 - costheta) * r.x * r.z - r.y * sintheta) * p.x;
		z += ((1 - costheta) * r.y * r.z + r.x * sintheta) * p.y;
		z += (costheta + (1 - costheta) * r.z * r.z) * p.z;
	}

	static public v Normalize( v a){	return v.div(a,a.Length());}
	static public float Length( v a ){	return a.Length();}
	static public float Length2( v a ){	return a.Length2();}
	static public float Distance ( v a, v b){	return Length( v.sub(a,b) );}
	static public float Distance2 ( v a, v b){	return Length2( v.sub(a,b) );}

	static public v MakeNormal( v a, v b, v c)
	{
		return v.Normalize(v.CROSS( v.sub(b,a), v.sub(c,a)));
	}
	public String toString()
	{
		return ("["+x+","+y+","+z+"]");
	}
}
